| Home · All Classes · All Namespaces · Modules · Functions · Files

Public Types | Signals | Public Member Functions | Protected Member Functions

# Tp::MediaStream Class Reference
[Channel proxies]

The MediaStream class provides an object representing a Telepathy media stream. More...

`#include <TelepathyQt4/StreamedMediaChannel>`

Inherits Tp::ReadyObject, and Tp::RefCounted.

List of all members.

## Public Types

- enum SendingState { SendingStateNone, SendingStatePendingSend, SendingStateSending }

## Signals

- void localSendingStateChanged (Tp::MediaStream::SendingState localSendingState)
- void remoteSendingStateChanged (const QHash< Tp::ContactPtr, Tp::MediaStream::SendingState > &remoteSendingStates)
- void remoteSendingStateChanged (Tp::MediaStream::SendingState remoteSendingState)
- void membersRemoved (const Tp::Contacts &members)

## Public Member Functions

- ~MediaStream ()
- TELEPATHY_QT4_DEPRECATED
  MediaContentPtr content () const
- StreamedMediaChannelPtr channel () const
- uint id () const
- TELEPATHY_QT4_DEPRECATED Contacts members () const
- ContactPtr contact () const
- MediaStreamState state () const
- MediaStreamType type () const
- SendingState localSendingState () const
- SendingState remoteSendingState () const
- TELEPATHY_QT4_DEPRECATED
  SendingState remoteSendingState (const ContactPtr &contact) const
- bool sending () const
- bool receiving () const
- bool localSendingRequested () const
- bool remoteSendingRequested () const
- MediaStreamDirection direction () const
- MediaStreamPendingSend pendingSend () const
- PendingOperation * requestSending (bool send)
- PendingOperation * requestReceiving (bool receive)
- TELEPATHY_QT4_DEPRECATED
  PendingOperation * requestReceiving (const ContactPtr &contact, bool receive)
- PendingOperation * requestDirection (MediaStreamDirection direction)
- PendingOperation * requestDirection (bool send, bool receive)
- PendingOperation * startDTMFTone (DTMFEvent event)
- PendingOperation * stopDTMFTone ()

## Protected Member Functions

- void connectNotify (const char *)

## Detailed Description

The MediaStream class provides an object representing a Telepathy media stream.

Instances of this class cannot be constructed directly; the only way to get one is via StreamedMediaChannel.

See Asynchronous Object Model

## Member Enumeration Documentation

enum Tp::MediaStream::SendingState

Enumerator:

  SendingStateNone |
  SendingStatePendingSend |
  SendingStateSending |

## Constructor & Destructor Documentation

Tp::MediaStream::~MediaStream | ( |  | ) |

Class destructor.

## Member Function Documentation

MediaContentPtr Tp::MediaStream::content | ( |  | ) | const

Return the content owning this media stream.

Deprecated:

Returns:
  The content owning this media stream.

StreamedMediaChannelPtr Tp::MediaStream::channel | ( |  | ) | const

Return the channel owning this media stream.

Returns:
  The channel owning this media stream.

uint Tp::MediaStream::id | ( |  | ) | const

Return the id of this media stream.

Returns:
  An integer representing the media stream id.

Contacts Tp::MediaStream::members | ( |  | ) | const

Return the contacts whose the media stream is with.

Deprecated:
  Use contact() instead.

Returns:
  The contacts whose the media stream is with.

See also:
  membersRemoved()

ContactPtr Tp::MediaStream::contact | ( |  | ) | const

Return the contact who this media stream is with.

Returns:
  The contact who this media stream is with.

MediaStreamState Tp::MediaStream::state | ( |  | ) | const

Return the state of this media stream.

Returns:
  The state of this media stream.

MediaStreamType Tp::MediaStream::type | ( |  | ) | const

Return the type of this media stream.

Returns:
  The type of this media stream.

MediaStream::SendingState Tp::MediaStream::localSendingState | ( |  | ) | const

Return the media stream local sending state.

Returns:
  The media stream local sending state.

See also:
  localSendingStateChanged()

MediaStream::SendingState Tp::MediaStream::remoteSendingState | ( |  | ) | const

Return the media stream remote sending state.

Returns:
  The media stream remote sending state.

See also:
  remoteSendingStateChanged()

MediaStream::SendingState Tp::MediaStream::remoteSendingState | ( | const ContactPtr & | contact | ) | const

Return the media stream remote sending state for a given contact.

Deprecated:
  Use remoteSendingState() instead.

Returns:
  The media stream remote sending state for a contact.

See also:
  remoteSendingStateChanged()

bool Tp::MediaStream::sending | ( |  | ) | const

Return whether media is being sent on this media stream.

Returns:
  `true` if media being sent on this media stream, `false` otherwise.

See also:
  localSendingStateChanged()

bool Tp::MediaStream::receiving | ( |  | ) | const

Return whether media is being received on this media stream.

Returns:
  `true` if media is being received on this media stream, `false` otherwise.

See also:
  remoteSendingStateChanged()

bool Tp::MediaStream::localSendingRequested | ( |  | ) | const

Return whether the local user has been asked to send media by the remote user on this media stream.

Returns:
  `true` if the local user has been asked to send media by the remote user on this media stream, `false` otherwise.

See also:
  localSendingStateChanged()

bool Tp::MediaStream::remoteSendingRequested | ( |  | ) | const

Return whether the remote user has been asked to send media by the local user on this media stream.

Returns:
  `true` if the remote user has been asked to send media by the local user on this media stream, `false` otherwise.

See also:
  remoteSendingStateChanged()

MediaStreamDirection Tp::MediaStream::direction | ( |  | ) | const

Return the direction of this media stream.

Returns:
  The direction of this media stream.

See also:
  localSendingStateChanged(), remoteSendingStateChanged()

MediaStreamPendingSend Tp::MediaStream::pendingSend | ( |  | ) | const

Return the pending send flags of this media stream.

Returns:
  The pending send flags of this media stream.

See also:
  localSendingStateChanged()

PendingOperation * Tp::MediaStream::requestSending | ( | bool | send | ) |

Request that media starts or stops being sent on this media stream.

Returns:
  A PendingOperation which will emit PendingOperation::finished when the call has finished.

See also:
  localSendingStateChanged()

PendingOperation * Tp::MediaStream::requestReceiving | ( | bool | receive | ) |

Request that the remote contact stops or starts sending on this media stream.

Returns:
  A PendingOperation which will emit PendingOperation::finished when the call has finished.

See also:
  remoteSendingStateChanged()

PendingOperation * Tp::MediaStream::requestReceiving | ( | const ContactPtr & | contact,
|  | bool | receive |
| ) |  |  |

Request that a remote contact stops or starts sending on this media stream.

Deprecated:
  Use requestReceiving(bool receive) instead.

Returns:
  A PendingOperation which will emit PendingOperation::finished when the call has finished.

See also:
  remoteSendingStateChanged()

PendingOperation * Tp::MediaStream::requestDirection | ( | MediaStreamDirection | direction | ) |

Request a change in the direction of this media stream. In particular, this might be useful to stop sending media of a particular type, or inform the peer that you are no longer using media that is being sent to you.

Parameters:

  | direction | The new direction.

Returns:
  A PendingOperation which will emit PendingOperation::finished when the call has finished.

See also:
  localSendingStateChanged(), remoteSendingStateChanged()

PendingOperation * Tp::MediaStream::requestDirection | ( | bool | send,
|  | bool | receive |
| ) |  |  |

Request a change in the direction of this media stream. In particular, this might be useful to stop sending media of a particular type, or inform the peer that you are no longer using media that is being sent to you.

Returns:
  A PendingOperation which will emit PendingOperation::finished when the call has finished.

See also:
  requestDirection(Tp::MediaStreamDirection direction)
  localSendingStateChanged(), remoteSendingStateChanged()

PendingOperation * Tp::MediaStream::startDTMFTone | ( | DTMFEvent | event | ) |

Start sending a DTMF tone on this media stream. Where possible, the tone will continue until stopDTMFTone() is called. On certain protocols, it may only be possible to send events with a predetermined length. In this case, the implementation may emit a fixed-length tone, and the stopDTMFTone() method call should return TELEPATHY_ERROR_NOT_AVAILABLE.

If the channel() does not support the TELEPATHY_INTERFACE_CHANNEL_INTERFACE_DTMF interface, the resulting PendingOperation will fail with error code TELEPATHY_ERROR_NOT_IMPLEMENTED.

Parameters:

  | event | A numeric event code from the DTMFEvent enum.

Returns:
  A PendingOperation which will emit PendingOperation::finished when the request finishes.

See also:
  stopDTMFTone()

PendingOperation * Tp::MediaStream::stopDTMFTone | ( |  | ) |

Stop sending any DTMF tone which has been started using the startDTMFTone() method. If there is no current tone, the resulting PendingOperation will finish successfully.

If continuous tones are not supported by this media stream, the resulting PendingOperation will fail with error code TELEPATHY_ERROR_NOT_AVAILABLE.

If the channel() does not support the TELEPATHY_INTERFACE_CHANNEL_INTERFACE_DTMF interface, the resulting PendingOperation will fail with error code TELEPATHY_ERROR_NOT_IMPLEMENTED.

Returns:
  A PendingOperation which will emit PendingOperation::finished when the request finishes.

See also:
  startDTMFTone()

void Tp::MediaStream::localSendingStateChanged | ( | Tp::MediaStream::SendingState | localSendingState | ) | `[signal]`

This signal is emitted when the local sending state of this media stream changes.

Parameters:

  | localSendingState | The new local sending state of this media stream.

See also:
  localSendingState()

void Tp::MediaStream::remoteSendingStateChanged | ( | const QHash< Tp::ContactPtr, Tp::MediaStream::SendingState > & | remoteSendingStates | ) | `[signal]`

This signal is emitted when any remote sending state of this media stream changes.

Deprecated:
  Use remoteSendingStateChanged(Tp::MediaStream::SendingState) instead.

Parameters:

  | remoteSendingStates | The new remote sending states of this media stream.

See also:
  remoteSendingState()

void Tp::MediaStream::remoteSendingStateChanged | ( | Tp::MediaStream::SendingState | remoteSendingState | ) | `[signal]`

void Tp::MediaStream::membersRemoved | ( | const Tp::Contacts & | members | ) | `[signal]`

This signal is emitted when one or more members of this stream are removed.

Deprecated:

Parameters:

  | members | The members that were removed from this media stream.

See also:
  members()

void Tp::MediaStream::connectNotify | ( | const char * | signalName | ) | `[protected]`